{
   Info OGG
   par Fred MONTIN
   http://f.montin.free.fr
   08 Fvrier 2006
}

unit InfoOGG;

interface
 uses
  SysUtils, Classes, Dialogs, StrUtils;

  Type
   InfosOGG = record
         FileSize      : Integer;
         AudioChannels : Integer;
         SampleRate    : integer;
         BitrateMax    : integer;
         BitrateNom    : integer;
         BitrateMin    : integer;
         BitStream     : string;
         Title    : string;
         Artist   : string;
         Album    : string;
         Track    : string;
         Genre    : string;
         Date     : string;
         Comment  : string;
         Comments : TStringList;
         Vendor   : string;
  end;

  Function  LireInfosOGG(Fichier :string): InfosOGG;
  Function  TexteInfosOGG(Fichier :string): String;
  Procedure EcrireInfosOGG(Fichier: string; NewInfo: InfosOGG);
  Function  CalculCRC(s : string): LongWord;

implementation

uses Unit1;

{-=-=-=-=-=-= LECTURE DES INFOS =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Function LireInfosOGG(Fichier :string): InfosOGG;
var
    Fs    : TFileStream;
    Info  : InfosOGG;
    i,j,n : integer;
    t     : string;
    c     : char;
    b     : array[1..4] of byte;
begin
With Info do
begin
  Fs := TFileStream.Create(Fichier, fmOpenRead or fmShareDenyNone);
  try
    Comments := TStringList.Create;
    FileSize := Fs.Size;

          {*** Page 1 ***}

    t := '';
    For j := 1 to 4 do
    begin
        Fs.read(c, 1);
        t := t + c;
    end;
    if t <> 'OggS' then Exit;

    Fs.Seek(22, soFromCurrent);
    Fs.read(b, 1);
    Fs.Seek(b[1] + 1, soFromCurrent);

        {*** Identification header ***}

    t := '';
    For j := 1 to 6 do
    begin
        Fs.read(c, 1);
        t := t + c;
    end;
    if t <> 'vorbis' then Exit;

    Fs.Seek(4, soFromCurrent);
    Fs.read(b, 1);
    AudioChannels := b[1];

    Fs.read(b, 4);
    SampleRate := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;

    Fs.read(b, 4);
    BitrateMax := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;

    Fs.read(b, 4);
    BitrateNom := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;

    Fs.read(b, 4);
    BitrateMin := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;

    if (BitrateMax = BitrateNom) and (BitrateNom = BitrateMin) then
        BitStream := 'CBR'                                // Constant BitRate
    else if (BitrateMax = 0) and (BitrateMin = 0) then
        BitStream := 'VBR Nominal'                        // Variable BitRate arround a Nominal
    else
        BitStream := 'VBR Limits';                        // Variable BitRate between Limits

          {*** Page 2 ***}

    Fs.Seek(28, soFromCurrent);
    Fs.read(b, 1);
    Fs.Seek(b[1] + 1, soFromCurrent);

        {*** Comment header ***}

    t := '';
    For j := 1 to 6 do
    begin
        Fs.read(c, 1);
        t := t + c;
    end;
    if t <> 'vorbis' then Exit;

    Fs.read(b, 4);                       // Taille du Vendor
    i := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;
    For j := 1 to i do                   // Lit le Vendor
    begin
        Fs.read(c, 1);
        Vendor := Vendor + c;
    end;

    Fs.read(b, 4);                       // Nombre de comments
    n := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;
    while n > 0 do
    begin
        Fs.read(b, 4);                   // Taille du comment
        i := b[1] + b[2] * $100 + b[3] * $10000 + b[4] * $1000000;
        t := '';
        For j := 1 to i do               // Lit le comment
        begin
            Fs.read(c, 1);
            t := t + c;
        end;
        Comments.Add(t);            // Ajoute le comment  la liste des Comments
        Dec(n);
    end;

    For i := 0 to Comments.Count - 1 do  // Extrait les principaux comments de la liste
    begin
        If AnsiStartsText('TITLE=', Comments[i]) then
            Title := Copy(Comments[i], 7, Length(Comments[i]));
        If AnsiStartsText('ARTIST=', Comments[i]) then
            Artist := Copy(Comments[i], 8, Length(Comments[i]));
        If AnsiStartsText('ALBUM=', Comments[i]) then
            Album := Copy(Comments[i], 7, Length(Comments[i]));
        If AnsiStartsText('TRACKNUMBER=', Comments[i]) then
            Track := Copy(Comments[i], 13, Length(Comments[i]));
        If AnsiStartsText('GENRE=', Comments[i]) then
            Genre := Copy(Comments[i], 7, Length(Comments[i]));
        If AnsiStartsText('DATE=', Comments[i]) then
            Date := Copy(Comments[i], 6, Length(Comments[i]));
        If AnsiStartsText('COMMENT=', Comments[i]) then
            Comment := Copy(Comments[i], 9, Length(Comments[i]));
    end;
  finally
    Fs.Free;
    Result := Info;
  end;
end;
end;

{-=-=-=-=-=-= LECTURE DES INFOS PUIS REPORT SOUS FORMAT TEXTE =-=-=-=-=-=-=-=-=-=-=-}
Function TexteInfosOGG(Fichier :string): String;
var
    I : InfosOGG;
    t : TStringList;
begin
    I := LireInfosOGG(Fichier);
    t := TStringList.Create;
    with I do begin
      with t do begin
          Add(Format('Size : %d bytes', [FileSize]));
          Add(Format('Channels : %d', [AudioChannels]));
          Add(Format('Sample Rate : %d Hz', [SampleRate]));
          Add(Format('BitStream : %s', [BitStream]));
          Add(Format('Bitrate Max : %f Kbit/s', [BitrateMax / 1024]));
          Add(Format('Bitrate Nominal : %f Kbit/s', [BitrateNom / 1024]));
          Add(Format('Bitrate Min : %f Kbit/s', [BitrateMin / 1024]));
          Result := Text;
          Free;
      end;
    end;
end;

{-=-=-=-=-=-= ECRITURE DES INFOS =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Procedure EcrireInfosOGG(Fichier: string; NewInfo: InfosOGG);
var
    Source, Destination : TFileStream;
    b                   : Array[1..4] of byte;
    i, j                : integer;
    BufferName          : string;
    r                   : longword;
    t, t2               : string;
    c                   : char;
    PagePos, MetaPos, CRCPos, MetaLength, PageLength : integer;
    NewTagData          : string;
    d                   : byte;
begin
  if (not FileExists(Fichier)) or (FileSetAttr(Fichier, 0) <> 0) then Exit;
  BufferName := Fichier + '~';
  Source := TFileStream.Create(Fichier, fmOpenRead or fmShareExclusive);
  Destination := TFileStream.Create(BufferName, fmCreate);
  try
            { charge les infos du fichier source }
              {*** Page 1 ***}
    t := '';
    For j := 1 to 4 do
    begin
        Source.read(c, 1);
        t := t + c;
    end;
    if t <> 'OggS' then Exit;

    Source.Seek(22, soFromCurrent);
    Source.read(b, 1);
    Source.Seek(b[1] + 1, soFromCurrent);
        {*** Identification header ***}
    t := '';
    For j := 1 to 6 do
    begin
        Source.read(c, 1);
        t := t + c;
    end;
    if t <> 'vorbis' then Exit;

    PagePos := Source.Position + 23;
    CRCPos := PagePos + 22;
    Source.Seek(49, soFromCurrent);
    Source.read(b[1], 1);
    PageLength := Source.Position - PagePos + b[1];
    MetaLength := 0;
    j := 0;
    for i := 1 to b[1] do
    begin
        Source.Read(b[2], 1);
        j := j + b[2];
        if (b[2] < 255) and (MetaLength = 0) then
             MetaLength := j - 8;
    end;
    PageLength := PageLength + j;
    MetaPos := Source.Position + 7;

            { on reconstruit les comments }
    i := 0;
    With NewInfo do
    begin
      while i < Comments.Count do
      begin
        if AnsiStartsText('TITLE=',       Comments[i])
        or AnsiStartsText('ARTIST=',      Comments[i])
        or AnsiStartsText('ALBUM=',       Comments[i])
        or AnsiStartsText('TRACKNUMBER=', Comments[i])
        or AnsiStartsText('GENRE=',       Comments[i])
        or AnsiStartsText('DATE=',        Comments[i])
        or AnsiStartsText('COMMENT=',     Comments[i]) then
            Comments.Delete(i)
        else
            Inc(i);
      end;
      If Title   <> '' then Comments.Add('TITLE='       + Title);
      If Artist  <> '' then Comments.Add('ARTIST='      + Artist);
      If Album   <> '' then Comments.Add('ALBUM='       + Album);
      If Track   <> '' then Comments.Add('TRACKNUMBER=' + Track);
      If Genre   <> '' then Comments.Add('GENRE='       + Genre);
      If Date    <> '' then Comments.Add('DATE='        + Date);
      If Comment <> '' then Comments.Add('COMMENT='     + Comment);
    end;

    Source.Seek(PagePos, soFromBeginning);
    NewTagData := '';
    For i := PagePos to CRCPos - 1 do
    begin
        Source.Read(d, 1);
        NewTagData := NewTagData + IntToHex(d, 2);
    end;
    Source.Seek(4, soFromCurrent);
    NewTagData := NewTagData + '00000000';
    For i := CRCPos + 4 to MetaPos - 1 do
    begin
        Source.Read(d, 1);
        NewTagData := NewTagData + IntToHex(d, 2);
    end;

    b[4] := Length(NewInfo.Vendor) div $1000000;
    b[3] := Length(NewInfo.Vendor) div $10000;
    b[2] := Length(NewInfo.Vendor) div $100;
    b[1] := Length(NewInfo.Vendor) mod $100;
    for i := 1 to 4 do
        NewTagData := NewTagData + IntToHex(b[i], 2);
    for i := 1 to Length(NewInfo.Vendor) do
        NewTagData := NewTagData + IntToHex(Ord(NewInfo.Vendor[i]), 2);

    b[4] := NewInfo.Comments.Count div $1000000;
    b[3] := NewInfo.Comments.Count div $10000;
    b[2] := NewInfo.Comments.Count div $100;
    b[1] := NewInfo.Comments.Count mod $100;
    for i := 1 to 4 do
        NewTagData := NewTagData + IntToHex(b[i], 2);
    for j := 0 to NewInfo.Comments.Count - 1 do
    begin
        b[4] := Length(NewInfo.Comments[j]) div $1000000;
        b[3] := Length(NewInfo.Comments[j]) div $10000;
        b[2] := Length(NewInfo.Comments[j]) div $100;
        b[1] := Length(NewInfo.Comments[j]) mod $100;
        for i := 1 to 4 do
            NewTagData := NewTagData + IntToHex(b[i], 2);
        for i := 1 to Length(NewInfo.Comments[j]) do
            NewTagData := NewTagData + IntToHex(Ord(NewInfo.Comments[j][i]), 2);
    end;

    Source.Seek(MetaLength, soFromCurrent);

    For i := Source.Position - PagePos to PageLength - 1 do
    begin
        Source.Read(d, 1);
        NewTagData := NewTagData + IntToHex(d, 2);
    end;

    j := (PagePos + PageLength) - (MetaPos + MetaLength) - 1;          // Longeur du segment 2
    i := (Length(NewTagData) div 2) - (MetaPos - 8 - PagePos) - j - 1; // Longeur du segment 1

    t := DupeString('FF', i div $FF);
    t := t + IntToHex(i mod $FF, 2);
    t := t + DupeString('FF', j div $FF);
    t := t + IntToHex(j mod $FF, 2);
    t := IntToHex(Length(t) div 2, 2) + t;

    t2 := Copy(NewTagData, 1, (CRCPos - PagePos + 4) * 2) + t + Copy(NewTagData, (MetaPos - PagePos - 7) * 2 + 1, Length(NewTagData));
    NewTagData := t2;

    r := CalculCRC(NewTagData);
    if r = 0 then Exit;
    //ShowMessage(IntToHex(r, 8));

    t := Copy(NewTagData, 1, (CRCPos - PagePos) * 2);
    b[4] := r div $1000000;
    b[3] := r div $10000;
    b[2] := r div $100;
    b[1] := r mod $100;
    for i := 1 to 4 do
        t := t + IntToHex(b[i], 2);
    NewTagData := t + copy(NewTagData, 53, Length(NewTagData));

    Source.Seek(0, soFromBeginning);
    Destination.CopyFrom(Source, PagePos);
    i := 1;
    while i < Length(NewTagData) do
    begin
        d := StrToInt('$' + Copy(NewTagData, i, 2));
        Destination.Write(d, 1);
        i := i + 2;
    end;
    Source.Seek(PageLength + PagePos, soFromBeginning);
    Destination.CopyFrom(Source, Source.Size - Source.Position);

    Destination.Free;
    Source.Free;
    if (DeleteFile(Fichier)) then RenameFile(BufferName, Fichier)
  except
    Destination.Free;
    Source.Free;
    if FileExists(BufferName) then DeleteFile(BufferName);
  end;
end;

{-=-=-=-=-=-= CALCUL DU CRC =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Function  CalculCRC(s : string) : LongWord;
var
    i, j           : integer;
    sbin, polybin  : string;
    restei, restef : string;
    CRC            : string;
    bit0           : boolean;
const
    HexVersBin : array[0..15] of string[4] = ('0000','0001','0010','0011','0100','0101','0110','0111','1000','1001','1010','1011','1100','1101','1110','1111');
    poly : string[8] = '04C11DB7';
begin
  try
    sbin := '';
    for i := 1 to length(s) do                                 // On convertit 's' en binaire
        sbin := sbin + HexVersBin[StrToInt('$' + s[i])];

    polybin := '';
    for i := 1 to length(poly) do                              // On convertit 'poly' en binaire
        polybin := polybin + HexVersBin[StrToInt('$' + poly[i])];

    sbin := sbin + DupeString('0', Length(polybin));           // On rajoute autant de zro a la fin de 'sbin' que la longueur de 'polybin'

    j := Length(polybin);
    restef := Copy(sbin, 1, j);             // Initialise 'restef'

    while j <= Length(sbin) - 1 do          // Calcul du CRC
    begin
        Inc(j);
        bit0 := (restef[1] = '1');                             // On regarde le premier bit de 'restef'
        restei := Copy(restef, 2, length(restef)) + sbin[j];   // On dcale de 1 bit ves la droite
        if bit0 then                                           // On fait le xor avec 'polybin'
        begin
            restef := '';
            for i := 1 to Length(polybin) do
                restef := restef + IntToStr(StrToInt(restei[i]) xor StrToInt(polybin[i]));
        end else begin                                         // On fait le xor avec 00000...
            restef := restei;
        end;
    end;

    CRC := '';                              // On convertit le 'restef' final du binaire  l'hexa
    for j := 0 to Length(restef) - 4 do
      if (j mod 4) = 0 then
      begin
        i := 0;
        while HexVersBin[i] <> copy(restef, j + 1, 4) do
            Inc(i);
        CRC := CRC + IntToHex(i, 1);
      end;
    Result := StrToInt64('$' + CRC);
  except
    Result := 0;
  end;
end;


end.
