{
   Info WMA
   par Fred MONTIN
   http://f.montin.free.fr
   2 Fvrier 2006
}

unit InfoWMA;

interface
 uses
  SysUtils, Classes, Dialogs, StrUtils;

  Type
   InfosWMA = record
         FileSize : Integer;
         Title    : string;
         Artist   : string;
         Album    : string;
         Genre    : string;
         Track    : string;
         Year     : string;
         Descriptors : TStringList;
  end;

  Function LireInfosWMA(Fichier :string): InfosWMA;

implementation

uses Unit1;

{-=-=-=-=-=-= LECTURE DES INFOS =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Function LireInfosWMA(Fichier :string): InfosWMA;
var
    Fs      : TFileStream;
    Info    : InfosWMA;
    i,n,j   : Integer;
    t       : string;
    b       : array[1..8] of byte;
    GUID    : array[1..16] of byte;
    OK      : boolean;
    c       : Char;
    u       : byte;
    TitleLength, AuthorLength : Integer;
const
    ID_TopHeader : Array[1..16] of byte = (48,38,178,117,142,102,207,17,166,217,0,170,0,98,206,108);
    ID_CDO       : Array[1..16] of byte = (51,38,178,117,142,102,207,17,166,217,0,170,0,98,206,108);
    ID_Ext_CDO   : Array[1..16] of byte = (64,164,208,210,7,227,210,17,151,240,0,160,201,94,168,80);
begin

With Info do
begin
  Descriptors := TStringList.Create;
  Fs := TFileStream.Create(Fichier, fmOpenRead or fmShareDenyNone);
  try
      FileSize := Fs.Size;

{*******************************************************************************}
      Fs.Read(GUID, 16);                                                        // ASF top-level Header Object
      OK := True;
      for i := 1 to 16 do
          if GUID[i] <> ID_TopHeader[i] then OK := False;                       // On vrifie que le fichier est bon
      if Not(OK) then Exit;

      Fs.Read(b, 8);                                                            // Taille du Header Object
      Fs.Read(b, 4);                                                            // Number of header objects
      n := b[1] + b[2] * 256 + b[3] * 65536 + b[4] * 16777216;
      Fs.Read(b, 2);                                                            // Reserved Bytes
      While n > 0 do
      begin
          Fs.Read(GUID, 16);                                                    // GUID
          OK := True;
          for i := 1 to 16 do
              if GUID[i] <> ID_CDO[i] then OK := False;                         // On cherche le GUID du CDO (Content Description Object)
          Fs.Read(b, 8);                                                        // Taille du CDO
          i := b[1] + b[2] * 256 + b[3] * 65536 + b[4] * 16777216;
          if OK then Break;                                                     // C'est trouv on quitte la boucle
          Fs.Seek(i - 24, soFromCurrent);                                       // C'est pas trouv on saute au Header Object suivant
          Dec(n);
      end;

      if OK then                                                                // On l'a trouv !
      begin
          Fs.Read(b, 2);                                                        // TitleLength
          TitleLength := b[1] + b[2] * 256;
          Fs.Read(b, 2);                                                        // AuthorLength
          AuthorLength := b[1] + b[2] * 256;
          Fs.Read(b, 6);                                                        // CopytightLength + DescriptionLength + RatingLength
          //Fs.Read(b, 2);
          //CopyrightLength := b[1] + b[2] * 256;
          //Fs.Read(b, 2);
          //DescriptionLength := b[1] + b[2] * 256;
          //Fs.Read(b, 2);
          //RatingLength := b[1] + b[2] * 256;
          for i := 1 to TitleLength do                                          // Title
          begin
              Fs.Read(c, 1);
              if Ord(c) <> 0 then Title := Title + c;
          end;
          for i := 1 to AuthorLength do                                         // Artist
          begin
              Fs.Read(c, 1);
              if Ord(c) <> 0 then Artist := Artist + c;
          end;
      end;

{*******************************************************************************}
      Fs.Seek(0, soFromBeginning);                                              // Retour au dbut du fichier
      Fs.Read(GUID, 16);                                                        // ASF top-level Header Object
      Fs.Read(b, 8);                                                            // Taille du Header Object
      Fs.Read(b, 4);                                                            // Number of header objects
      n := b[1] + b[2] * 256 + b[3] * 65536 + b[4] * 16777216;
      Fs.Read(b, 2);                                                            // Reserved Bytes
      While n > 0 do
      begin
          Fs.Read(GUID, 16);                                                    // GUID
          OK := True;
          for i := 1 to 16 do
              if GUID[i] <> ID_Ext_CDO[i] then OK := False;                     // On cherche le GUID du ExtCDO (Extended Content Description Object)
          Fs.Read(b, 8);                                                        // Taille du ExtCDO
          i := b[1] + b[2] * 256 + b[3] * 65536 + b[4] * 16777216;
          if OK then Break;                                                     // C'est trouv on quitte la boucle
          Fs.Seek(i - 24, soFromCurrent);                                       // C'est pas trouv on saute au Header Object suivant
          Dec(n);
      end;

      if OK then                                                                // On l'a trouv !
      begin
          Fs.Read(b, 2);                                                        // Number of Content Descriptors
          n := b[1] + b[2] * 256;
          While n > 0 do
          begin
              Fs.Read(b, 2);                                                    // Longueur du Nom du decriptor
              i := b[1] + b[2] * 256;
              t := '';
              For j := 1 to i do
              begin
                  Fs.Read(c, 1);
                  if Ord(c) <> 0 then t := t + c;
              end;
              Descriptors.Add(t);                                               // Nom du descriptor

              Fs.Read(b, 2);                                                    // Type de descriptor
              u := b[1];
              Fs.Read(b, 2);
              i := b[1] + b[2] * 256;
              if (u = 0) or (u = 1) then                                        // Si Texte ou Array of byte
              begin
                  t := '';
                  For j := 1 to i do
                  begin
                      Fs.Read(c, 1);
                      if Ord(c) <> 0 then t := t + c;
                  end;
              end else begin                                                    // Si Entier ou Boolean
                  For j := 1 to 4 do
                      b[j] := 0;
                  Fs.Read(b, i);
                  i := b[1] + b[2] * 256 + b[3] * 65536 + b[4] * 16777216;
                  t := IntToStr(i);
              end;
              Descriptors.Add(t);
              Dec(n);
          end;
      end;

{*******************************************************************************}
      For i := 0 to Descriptors.Count - 1 do
      begin
          If Descriptors[i] = 'WM/AlbumTitle' then
              Album := Trim(Descriptors[i + 1]);
          If Descriptors[i] = 'WM/TrackNumber' then
              Track := Trim(Descriptors[i + 1]);
          If Descriptors[i] = 'WM/Genre' then
              Genre := Trim(Descriptors[i + 1]);
          If Descriptors[i] = 'WM/Year' then
              Year := Trim(Descriptors[i + 1]);
      end;

  finally
      Fs.Free;
      Result := Info;
  end;
end;

end;




end.
